/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _NISPASSWD_H_RPCGEN
#define _NISPASSWD_H_RPCGEN

#include <rpc/rpc.h>


enum nispasswd_status {
	NPD_SUCCESS = 0,
	NPD_TRYAGAIN = 1,
	NPD_PARTIALSUCCESS = 2,
	NPD_FAILED = 3,
};
typedef enum nispasswd_status nispasswd_status;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_status(XDR *, nispasswd_status*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_status(XDR *, nispasswd_status*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_status();
#endif /* Old Style C */ 


enum nispasswd_code {
	NPD_NOTMASTER = 0,
	NPD_NOSUCHENTRY = 1,
	NPD_IDENTINVALID = 2,
	NPD_NOPASSWD = 3,
	NPD_NOSHDWINFO = 4,
	NPD_SHDWCORRUPT = 5,
	NPD_NOTAGED = 6,
	NPD_CKGENFAILED = 7,
	NPD_VERFINVALID = 8,
	NPD_PASSINVALID = 9,
	NPD_ENCRYPTFAIL = 10,
	NPD_DECRYPTFAIL = 11,
	NPD_KEYSUPDATED = 12,
	NPD_KEYNOTREENC = 13,
	NPD_PERMDENIED = 14,
	NPD_SRVNOTRESP = 15,
	NPD_NISERROR = 16,
	NPD_SYSTEMERR = 17,
	NPD_BUFTOOSMALL = 18,
	NPD_INVALIDARGS = 19,
};
typedef enum nispasswd_code nispasswd_code;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_code(XDR *, nispasswd_code*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_code(XDR *, nispasswd_code*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_code();
#endif /* Old Style C */ 


enum nispasswd_field {
	NPD_PASSWD = 0,
	NPD_GECOS = 1,
	NPD_SHELL = 2,
	NPD_SECRETKEY = 3,
};
typedef enum nispasswd_field nispasswd_field;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_field(XDR *, nispasswd_field*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_field(XDR *, nispasswd_field*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_field();
#endif /* Old Style C */ 


struct nispasswd_error {
	nispasswd_field npd_field;
	nispasswd_code npd_code;
	struct nispasswd_error *next;
};
typedef struct nispasswd_error nispasswd_error;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_error(XDR *, nispasswd_error*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_error(XDR *, nispasswd_error*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_error();
#endif /* Old Style C */ 


struct passwd_info {
	char *pw_gecos;
	char *pw_shell;
};
typedef struct passwd_info passwd_info;
#ifdef __cplusplus 
extern "C" bool_t xdr_passwd_info(XDR *, passwd_info*);
#elif __STDC__ 
extern  bool_t xdr_passwd_info(XDR *, passwd_info*);
#else /* Old Style C */ 
bool_t xdr_passwd_info();
#endif /* Old Style C */ 


struct npd_request {
	char *username;
	char *domain;
	char *key_type;
	struct {
		u_int user_pub_key_len;
		u_char *user_pub_key_val;
	} user_pub_key;
	struct {
		u_int npd_authpass_len;
		u_char *npd_authpass_val;
	} npd_authpass;
	u_long ident;
};
typedef struct npd_request npd_request;
#ifdef __cplusplus 
extern "C" bool_t xdr_npd_request(XDR *, npd_request*);
#elif __STDC__ 
extern  bool_t xdr_npd_request(XDR *, npd_request*);
#else /* Old Style C */ 
bool_t xdr_npd_request();
#endif /* Old Style C */ 

#define __NPD_MAXPASSBYTES 12

typedef char passbuf[__NPD_MAXPASSBYTES];
#ifdef __cplusplus 
extern "C" bool_t xdr_passbuf(XDR *, passbuf);
#elif __STDC__ 
extern  bool_t xdr_passbuf(XDR *, passbuf);
#else /* Old Style C */ 
bool_t xdr_passbuf();
#endif /* Old Style C */ 


struct npd_newpass {
	u_long npd_xrandval;
	passbuf pass;
};
typedef struct npd_newpass npd_newpass;
#ifdef __cplusplus 
extern "C" bool_t xdr_npd_newpass(XDR *, npd_newpass*);
#elif __STDC__ 
extern  bool_t xdr_npd_newpass(XDR *, npd_newpass*);
#else /* Old Style C */ 
bool_t xdr_npd_newpass();
#endif /* Old Style C */ 


struct npd_update {
	u_long ident;
	npd_newpass xnewpass;
	passwd_info pass_info;
};
typedef struct npd_update npd_update;
#ifdef __cplusplus 
extern "C" bool_t xdr_npd_update(XDR *, npd_update*);
#elif __STDC__ 
extern  bool_t xdr_npd_update(XDR *, npd_update*);
#else /* Old Style C */ 
bool_t xdr_npd_update();
#endif /* Old Style C */ 


struct nispasswd_verf {
	u_long npd_xid;
	u_long npd_xrandval;
};
typedef struct nispasswd_verf nispasswd_verf;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_verf(XDR *, nispasswd_verf*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_verf(XDR *, nispasswd_verf*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_verf();
#endif /* Old Style C */ 


struct nispasswd_authresult {
	nispasswd_status status;
	union {
		nispasswd_verf npd_verf;
		nispasswd_code npd_err;
	} nispasswd_authresult_u;
};
typedef struct nispasswd_authresult nispasswd_authresult;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_authresult(XDR *, nispasswd_authresult*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_authresult(XDR *, nispasswd_authresult*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_authresult();
#endif /* Old Style C */ 


struct nispasswd_updresult {
	nispasswd_status status;
	union {
		nispasswd_error reason;
		nispasswd_code npd_err;
	} nispasswd_updresult_u;
};
typedef struct nispasswd_updresult nispasswd_updresult;
#ifdef __cplusplus 
extern "C" bool_t xdr_nispasswd_updresult(XDR *, nispasswd_updresult*);
#elif __STDC__ 
extern  bool_t xdr_nispasswd_updresult(XDR *, nispasswd_updresult*);
#else /* Old Style C */ 
bool_t xdr_nispasswd_updresult();
#endif /* Old Style C */ 


#define NISPASSWD_PROG ((u_long)100303)
#define NISPASSWD_VERS ((u_long)1)

#ifdef __cplusplus
#define NISPASSWD_AUTHENTICATE ((u_long)1)
extern "C" nispasswd_authresult * nispasswd_authenticate_1(npd_request *, CLIENT *);
extern "C" nispasswd_authresult * nispasswd_authenticate_1_svc(npd_request *, struct svc_req *);
#define NISPASSWD_UPDATE ((u_long)2)
extern "C" nispasswd_updresult * nispasswd_update_1(npd_update *, CLIENT *);
extern "C" nispasswd_updresult * nispasswd_update_1_svc(npd_update *, struct svc_req *);

#elif __STDC__
#define NISPASSWD_AUTHENTICATE ((u_long)1)
extern  nispasswd_authresult * nispasswd_authenticate_1(npd_request *, CLIENT *);
extern  nispasswd_authresult * nispasswd_authenticate_1_svc(npd_request *, struct svc_req *);
#define NISPASSWD_UPDATE ((u_long)2)
extern  nispasswd_updresult * nispasswd_update_1(npd_update *, CLIENT *);
extern  nispasswd_updresult * nispasswd_update_1_svc(npd_update *, struct svc_req *);

#else /* Old Style C */ 
#define NISPASSWD_AUTHENTICATE ((u_long)1)
extern  nispasswd_authresult * nispasswd_authenticate_1();
extern  nispasswd_authresult * nispasswd_authenticate_1_svc();
#define NISPASSWD_UPDATE ((u_long)2)
extern  nispasswd_updresult * nispasswd_update_1();
extern  nispasswd_updresult * nispasswd_update_1_svc();
#endif /* Old Style C */ 

#endif /* !_NISPASSWD_H_RPCGEN */
